

#include "psim.h"

typedef int generator_proc_ptr(float E);
extern generator_proc_ptr photon;

int pairs(float E)
{

   /* GEANT has a rather fancy pair-production routine GPAIRG() */
   /* but it seems like it is not intended for use by the user  */
   /* directly, only internally by GEANT. It can be called,     */
   /* however, once tracking of a photon has started. Hence,    */
   /* we simply set a flag here and call the photon generator.  */
   /* Once tracking starts, it will catch the flag in gustep()  */
   /* and call GPAIRG() to generate the pair.                   */
	flags[pair_produce]=1;

	photon(E);

   return 0;
}














