CDECK  ID>, GXINT.  
      PROGRAM GXINT
*
*     GEANT main program. To link with the MOTIF user interface
*     the routine GPAWPP(NWGEAN,NWPAW) should be called, whereas
*     the routine GPAW(NWGEAN,NWPAW) gives access to the basic
*     graphics version.
*
      PARAMETER (NWGEAN=2000000,NWPAW=1000000)
      COMMON/GCBANK/GEANT(NWGEAN)
      COMMON/PAWC/PAW(NWPAW)
      COMMON/CHEREN/SHWDET(2048),TSHWDET(2048)
      COMMON/GCFLAX/BATCH,NOLOG
      LOGICAL BATCH,NOLOG
C
      COMMON/GLOBMEM/USEGM,GMNAM
      LOGICAL USEGM
      CHARACTER*4 GMNAM
C
      COMMON/GRAPHIC/USEGRAPH,VIEWTH,VIEWPH,VIEWPS,VSCALE
      LOGICAL USEGRAPH
*
      CALL INITC()
*
      IF(BATCH) THEN
        PRINT*,'Running in BATCH mode'
        CALL GZEBRA(NWGEAN)
        IF(USEGM) THEN
          CALL HLIMAP(NWPAW,GMNAM)
        ELSE
          CALL HLIMIT(-NWPAW)
        ENDIF
        
        CALL RUNBATCH
        
      ELSE
        CALL GPAW(NWGEAN,NWPAW)
      ENDIF
*
      END
      SUBROUTINE QNEXT
      END
      SUBROUTINE CZOPEN
      END
      SUBROUTINE CZTCP
      END
      SUBROUTINE CZCLOS
      END
      SUBROUTINE CZPUTA
      END
