C.
C.**************************************************************************
*____ Author :A. Gasparian                                                 *
*____ date : 10/29/95                                                      *
*                                                                          *
C..      TRACKING MEDIUMS                                                  *
C.                                                                         *
C
C   Modified 6/19/98  d. Lawrence
C
*.**************************************************************************
C
      SUBROUTINE GUTMED
C
      PARAMETER (KWBANK=69000,KWWORK=5200)
      COMMON/GCBANK/NZEBRA,GVERSN,ZVERSN,IXSTOR,IXDIV,IXCONS,FENDQ(16)
     +             ,LMAIN,LR1,WS(KWBANK)
      DIMENSION IQ(2),Q(2),LQ(8000),IWS(2)
      EQUIVALENCE (Q(1),IQ(1),LQ(9)),(LQ(1),LMAIN),(IWS(1),WS(1))
      EQUIVALENCE (JCG,JGSTAT)
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/MAGCUT/CUTMAG(10),MGNSTP
C
C...  OPTIC PROPERTES OF MEDUMES
      COMMON/OPTIC1/ABSTF1(15),EFFTF1(15),RINTF1(15)
      COMMON/OPTIC2/ABSSF5(15),EFFSF5(15),RINSF5(15)
      COMMON/OPTIC3/NACBIN,PPCKOV(15),BINCHP
      COMMON/OPTIC6/ABSAIR(15),EFFAIR(15),RINAIR(15)
      COMMON/OPTIC7/ABSALM(15),EFFALM(15),RINALM(15)
      COMMON/OPTI10/RINGLS(15),EFFGLS(15),ABSGLS(15)
      COMMON/OPTI11/FFETF1(15),FFESF5(15),FFEAIR(15)
C
      COMMON/ARMSPR/ELARMP(5),HDARMP(5)
C
C
C
C****************************************************
C               Table listing Tracking Media
C****************************************************
C.
      NMED1 = 1                ! AIR, NOT OPTIC                          # 1 
      NMED2 = 2                ! LEAD GLASS TF-1                         # 61
      NMED3 = 3                ! ALUMINIUM for metall mirror for modules!# 9
      NMED4 = 4                ! OPTIC AIR for cherenkov light tracking  # 1
      NMED5 = 5                ! PLASTIC SCINTILLATOR                    # 24
      NMED6 = 6                ! Glass for Tube TF-1                     # 15
      NMED7 = 7                ! VACUUM     NOT    MAGNETIC              # 16
      NMED8 = 8                ! Aluminum   NOT    Magnetic              # 17
      NMED9 = 9                ! Iron       Not    MAG ELEM              # 10
      NMED10=10                ! LIQ. Ne    Not    MAG ELEM              #  7
      NMED11=11                ! Vacuum            Magnetic              # 16
      NMED12=12                ! Iron              Magnetic              # 10
      NMED13=13                ! ALUMINIUM         MAGNETic              # 17
      NMED14=14                ! COPPER            Magnetic              # 11
      NMED15=15                ! LEAD COLL DIPOLE  Magnetic              # 28
      NMED16=16                ! IRON FOR MOL.TARG Not Magnetic          # 27
      NMED17=17                ! TH. LEAD FOR SHI$ Not Magnetic          # 29
      NMED18=18                ! TANGSTEN FOR DAN  Not Magnetic          # 12
      NMED19=19                ! MYLAR FOR ZOH'S W Not Magnetic          # 30
      NMED20=20                ! REDUCED LEAD TAR  Not Magnetic          # 81
      NMED21=21                ! REAL LEAD TARGET  Not Magnetic          # 82
      NMED22=22                ! PbWO4             Not Magnetic          # 63
      NMED23=23                ! Air               Magnetic              # 1
      NMED24=24                ! C7H14 Chamber Gas Not Magnetic          # 1
C
C
C****************************************************
C       Definitions of Tracking Media
C
C NOTE: The TMAXFD,STEMAX,DEEMAX, and STMIN values
C given are used ONLY if the IGAUTO variable is set
C to 0 (default is IGAUTO=1). see cons200-2 pg.50
C****************************************************
C
C
C
C****************************************************
C           Non-magnetic tracking media
C****************************************************
C
C
      IFIELD =  0
      FIELDM =  0.
      TMAXFD =  10.
      STEMAX =  10.
      DEEMAX =  0.1             ! FROM GEXAM1
      EPSIL  = 0.001
      STMIN  = 0.01             ! IN GEXAM8 = -0.01
C.
C.
      CALL GSTMED( 1,'DEFAULT MEDIUM AIR$ ' ,15 ,  0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 2,'LEAD GLASS TF-1$    '  ,61,  1 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 3,'ALUMINUM MIRROR$    '  , 9,  0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 4,'OPTICAL MEDIUM AIR$ ' , 15 , 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 5,'PLASTIC SCINTILLAT$ ' , 24,  1 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 6,'GLASS FOR TUBE TF1$ ' , 15,  1 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )   
      CALL GSTMED( 7,'VACUUM NOT MAGNETIC$' , 19, 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 8,'ALUMINIUM NOT MAGN.$' , 9 , 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 9,'IRON NOT MAGNETIC  $' , 10, 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 10,'LIQ. NITROG. N MAGN$' ,  7, 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 16,'IRON FOR MOL.TARGET$' , 27, 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 17,'THIERD LEAD FOR SHI$' ,29 ,  0 , IFIELD,
     *                FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 18,'TANGSTEN  NOT MAGNET' , 12, 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 19,'MYLAR FOR ZOHS WIND' , 30, 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 20,'REDUCEDLEAD TARGET$' , 81, 0 , IFIELD,
     +             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 24,'C7H14 Recoil gas target$' , 64, 0 , IFIELD,
     +             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
C
C
C                  Real density LEAD TARGET for Primakov Target          #21
C
      CALL GSTMED( 21,'REALLEAD TARGET$' , 82, 1 , IFIELD,
     +             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
C
C               Special Tracking Parameters for Pr. Lead Target
C
      CALL GSTPAR(21,'CUTGAM',0.001)
      CALL GSTPAR(21,'CUTELE',0.001)
      CALL GSTPAR(21,'CUTNEU',0.010)
      CALL GSTPAR(21,'CUTHAD',0.010)
      CALL GSTPAR(21,'CUTMUO',0.010)
      CALL GSTPAR(21,'BCUTE',0.001)



      CALL GSTMED( 22,'PbWO4$' , 63, 1 , IFIELD,
     +             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
C
C
C****************************************************
C       Magnetic tracking media
C****************************************************
C
      IFIELD = ELARMP(3) 
      FIELDM=20.                   ! MAX. FIELD IN KILOGAUSS
      TMAXFD = ELARMP(4)
C
      CALL GSTMED( 11,'VACUUM FOR MAGNET  $' ,16, 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 23,'AIR FOR MAG. FRINGE$' ,15, 0 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
C
C
      IFIELD = HDARMP(3) 
      FIELDM=20.                   ! MAX. FIELD IN KILOGAUSS
      TMAXFD = HDARMP(4)
C.
      CALL GSTMED( 12,'IRON FOR MAGNETIC  $' ,18, 1 , IFIELD,
     *             FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 13,'ALUMINUM MAGNETIC  $' ,17, 0 , IFIELD,
     *            FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 14,'COPPER MAGNETIC    $' ,11, 0 , 0,
     *                FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
      CALL GSTMED( 15,'LEAD COLL DIPOLE   $' ,28, 0 , IFIELD,
     *                FIELDM,TMAXFD,STEMAX,DEEMAX, EPSIL, STMIN, 0 , 0 )
C
C...      SPECIAL TRACKING PARAMETERS FOR MAG. SPECTROMETERS MEDIUMS
C.
      DO 512 I=11,15
C.
      CALL GSTPAR(I,'CUTGAM',CUTMAG(1))
      CALL GSTPAR(I,'CUTELE',CUTMAG(2))
      CALL GSTPAR(I,'CUTNEU',CUTMAG(3))
      CALL GSTPAR(I,'CUTHAD',CUTMAG(4))
      CALL GSTPAR(I,'CUTMUO',CUTMAG(5))
      CALL GSTPAR(I,'BCUTE' ,CUTMAG(1))
C.
512   CONTINUE
C
      CALL GSTPAR(23,'CUTGAM',CUTMAG(1))
      CALL GSTPAR(23,'CUTELE',CUTMAG(2))
      CALL GSTPAR(23,'CUTNEU',CUTMAG(3))
      CALL GSTPAR(23,'CUTHAD',CUTMAG(4))
      CALL GSTPAR(23,'CUTMUO',CUTMAG(5))
      CALL GSTPAR(23,'BCUTE' ,CUTMAG(1))

      RETURN
      END
C.
C.
C........














