C
C               This subr. defines vector prodact of two vectors
C                P1(A1,B1,C1)  and  P2(A2,B2,C2)
C       outputs; A3,B3, C3
C
C..................................................................
C
      SUBROUTINE VEC_PR(A1,B1,C1,A2,B2,C2,A3,B3,C3)
C
      DOUBLE PRECISION A1,B1,C1,A2,B2,C2,A3,B3,C3
      DOUBLE PRECISION VECLEN
C
      A3 = B1*C2-B2*C1
      B3 = C1*A2-C2*A1
      C3 = A1*B2-A2*B1
C
C                 Now normalization af vector to get COS's
      VECLEN = DSQRT(A3*A3+B3*B3+C3*C3)
C
      A3 = A3/VECLEN
      B3 = B3/VECLEN
      C3 = C3/VECLEN
C
      RETURN
      END
