C
C.>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C author A. Gasparian
C date   09/05/97
C         all pi0 measurements are here
C
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
      SUBROUTINE PI0_ME
C
C
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/KINEM1/EINI,TPI0,FIPI0G,EPI0SP,TRECSP,TKINRM
      COMMON/KINEM2/PPREL(3)
      COMMON/KINEM3/EPI0LF,PPI0LF(3),EG1LF,PG1LF(3),EG2LF,PG2LF(3)
C
      COMMON/PIKIN1/TPI0VP,FPI0VP
      COMMON/KING12/TG1CMG,FG1CMG
C
      COMMON/PI0DET/XYZG1(3),XYZG2(3)
      COMMON/PI0MES/TPIGEX,FPIGEX
      COMMON/PI0ME2/PSIEXP
      COMMON/TRANS1/TTRANS
      COMMON/TRANS2/EFMPI
      COMMON/PI0ME3/EG1LFE,EG2LFE
      COMMON/PI0ME4/TPIEX2,TPIEX3,EPI0EX             ! new 10/03/97
      COMMON/PI0ME5/CSPI02                           ! new 10/05/97
C
      COMMON/THARGT/THRPOS(3)
C
      COMMON/PERTUR/SIG(2)
C
      DIMENSION IR(3)
C
      DOUBLE PRECISION A(3,3),B(3,1)
      DOUBLE PRECISION CXPIEX,CYPIEX,CZPIEX
C
      DOUBLE PRECISION dx1,dy1,dz1,AL,dx2,dy2,dz2,BL
      DOUBLE PRECISION CXG1EX,CYG1EX,CZG1EX
      DOUBLE PRECISION CXG2EX,CYG2EX,CZG2EX
      DOUBLE PRECISION CSPSEX,DEG1,DEG2,CONT31,CSPI02,CSPI03
      DOUBLE PRECISION XSHER,CONT33
C
      DOUBLE PRECISION X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,A1,B1,C1,D1
      DOUBLE PRECISION APIG12,BPIG12,CPIG12,DPIG12
      DOUBLE PRECISION DCONS1,DCONS2,DCONS3
      DOUBLE PRECISION CSG0X,CSG0Y,CSG0Z
C
      DOUBLE PRECISION TWOPI
C
      PARAMETER (PI=3.1415926)
      PARAMETER (TWOPI=6.283185)
      PARAMETER (PIBY2=1.57079632)
      PARAMETER (DEGRAD=0.01745329)
      PARAMETER (RADDEG=57.29577951)
      PARAMETER (EMASS=0.00051099)
      PARAMETER (EMPI0=0.1349764)
CC      PARAMETER (PMASS=0.9382723128)
C
C
C
C          temp momentum of pi0
C
      PPI0D=SQRT(EPI0LF*EPI0LF-EMPI0*EMPI0)
C
      TTRANS=EMPI0*EMPI0-Q2-2.*OMEGA*EPI0LF+
     *2.*QVEC*PPI0D*COS(TDEGRAD*TPI0VP)
C
CC      write(*,*)'t= ',TTRANS,'  in GeV^2/C^2'
C
C      Opening Angle betwean g1 and g2 in Lab fram
C
      PG1PG2 = PG1LF(1)*PG2LF(1)+PG1LF(2)*PG2LF(2)+PG1LF(3)*PG2LF(3)
      CSPSI  = PG1PG2/(EG1LF*EG2LF)
      PSIG12 = RADDEG*ACOS(CSPSI)        ! in degrees
C
C don't need      CALL HF1(7,PSIG12,1.)
C
Ct      CALL HF1(9,PSIG12,1.)
C
C                 One Angle calculation from E1 E2 and PSI angle
C
      CONS6 = SQRT(EG1LF**2+2.*EG1LF*EG2LF*CSPSI+EG2LF**2)
      TET1  = RADDEG*ASIN((EG2LF*SIN(DEGRAD*PSIG12))/CONS6)
C
C
C
C................................................Gamma Energy PERTURBATION
      CALL RANNOR(AR,BR)
      IF(EG1LF.EQ.0.) GOTO 98
      EG1LFE= EG1LF*(1.+SIG(1)*AR/SQRT(EG1LF))
 98   IF(EG2LF.EQ.0.) GOTO 99
      EG2LFE= EG2LF*(1.+SIG(1)*BR/SQRT(EG2LF))
 99   CONTINUE
C.......................................................................
C
C                                                 Cooordinate perturbation
      CALL RANNOR(AR,BR)
      XG1EXP = XYZG1(1) + AR*SIG(2)/SQRT(EG1LF)
      YG1EXP = XYZG1(2) + BR*SIG(2)/SQRT(EG1LF)
      ZG1EXP = XYZG1(3)
CC      WRITE(6,*)'First Ex. Coor.=',XG1EXP,YG1EXP,ZG1EXP
C
      CALL RANNOR(AR,BR)
      XG2EXP = XYZG2(1) + AR*SIG(2)/SQRT(EG2LF)
      YG2EXP = XYZG2(2) + BR*SIG(2)/SQRT(EG2LF)
      ZG2EXP = XYZG2(3)
CC      WRITE(6,*)'Second Ex. Coor.=',XG2EXP,YG2EXP,ZG2EXP
C
C                  Effective mass calculation of Pi0 from g + g decay
C
C
      X1 = DBLE(XG1EXP)
      Y1 = DBLE(YG1EXP)                        ! G1
      Z1 = DBLE(ZG1EXP)
C
      X2 = DBLE(XG2EXP)
      Y2 = DBLE(YG2EXP)                        ! G2
      Z2 = DBLE(ZG2EXP)
C
      X3 = DBLE(THRPOS(1))
      Y3 = DBLE(THRPOS(2))                     ! Target
      Z3 = DBLE(THRPOS(3))
C
      dx1 = X1-X3
      dy1 = Y1-Y3
      dz1 = Z1-Z3
C
      AL = DSQRT(dx1*dx1+dy1*dy1+dz1*dz1)
C
C                                        Dir. COS's of the G1 line
      CXG1EX = dx1/AL
      CYG1EX = dy1/AL
      CZG1EX = dz1/AL
C
      dx2 = X2-X3
      dy2 = Y2-Y3
      dz2 = Z2-Z3
C
      BL = DSQRT(dx2*dx2+dy2*dy2+dz2*dz2)
C
C                                        Dir. COS's of the G2 line
      CXG2EX = dx2/BL
      CYG2EX = dy2/BL
      CZG2EX = dz2/BL
C
C                                       Defin. of G1 G1 openning angle
C
      CSPSEX = CXG1EX*CXG2EX+CYG1EX*CYG2EX+CZG1EX*CZG2EX
      PSIEXP = RADDEG*SNGL(DACOS(CSPSEX))       ! in degrees
C
CC      WRITE(6,*)'Lengths =',AL,BL,'PSIEXP =',PSIEXP
C                                                       pi0 eff. mass
      EFMPI2 = 2.*EG1LFE*EG2LFE*SNGL(1.D0 - CSPSEX)
      EFMPI  = SQRT(EFMPI2)
C
CC      WRITE(6,*)'Eff. Mass of Pi0 (MeV)',1000.*EFMPI
C
C
C                                        One angle Exp. measurement
C
      CONS7 = SQRT(EG1LFE**2+2.*EG1LFE*EG2LFE*CSPSEX+EG2LFE**2)
      TET1EX= RADDEG*ASIN((EG2LFE*SIN(DEGRAD*PSIEXP))/CONS7)
      TET2EX= PSIEXP-TET1EX
C
      DLTET1 = TET1-TET1EX
Ct      CALL HF1(32,DLTET1,1.)
Ct      CALL HF1(33,PSIG12-PSIEXP,1.)
C
CC      WRITE(6,*)'TET1= ',TET1,' TET1EX= ',TET1EX,' DTET1=',DLTET1
C
C
C                                       Def. of pi0=g1+g2 plane by 3 points
C
C      X1 = DBLE(XG1EXP)
C      Y1 = DBLE(YG1EXP)                        ! G1
C      Z1 = DBLE(ZG1EXP)
C
C      X2 = DBLE(XG2EXP)
C      Y2 = DBLE(YG2EXP)                        ! G2
C      Z2 = DBLE(ZG2EXP)
C
C      X3 = DBLE(THRPOS(1))
C      Y3 = DBLE(THRPOS(2))                     ! Target
C      Z3 = DBLE(THRPOS(3))
C
      CALL PLN_3P(X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,A1,B1,C1,D1)
C
      APIG12 = A1
      BPIG12 = B1                               ! They are COS's
      CPIG12 = C1
C
      DPIG12 = D1
C
C                                       Exp. Def. of the Pi0 Vect. COS's
C
C            With matrix Eq.    A * X = B
C
      A(1,1) = APIG12
      A(1,2) = BPIG12
      A(1,3) = CPIG12
      A(2,1) = CXG1EX
      A(2,2) = CYG1EX
      A(2,3) = CZG1EX
      A(3,1) = CXG2EX
      A(3,2) = CYG2EX
      A(3,3) = CZG2EX
C
      B(1,1) = 0.D0
      B(2,1) = DCOS(DBLE(DEGRAD*TET1EX))
      B(3,1) = DCOS(DBLE(DEGRAD*TET2EX))
C
C                                      CERN Mat Lib. 
      CALL DEQN(3,A,3,IR,IFAIL,1,B)
      IF(IFAIL.NE.0) go to 101
C
      CXPIEX = B(1,1)
      CYPIEX = B(2,1)     ! These are not norm. COS's of PI0 vec. EXPER.
      CZPIEX = B(3,1)
C
      DCONS1 = DSQRT(CXPIEX**2+CYPIEX**2+CZPIEX**2)
C
      CXPIEX = CXPIEX/DCONS1
      CYPIEX = CYPIEX/DCONS1      ! these are normalized COS's of Pi0
      CZPIEX = CZPIEX/DCONS1
C
CC      write(*,*)'Exp. COSs of Pi0 = ',CXPIEX,CYPIEX,CZPIEX
C
C     Now let us assume that Real Photon Beam is Parallel to Z axis
C
      CSG0X = 0.0D0
      CSG0Y = 0.0D0                        ! Incoming Real Photon  COS's
      CSG0Z = 1.0D0
C
      DCONS2 = DSQRT(CSG0X**2+CSG0Y**2+CSG0Z**2)
C
      CSG0X = CSG0X/DCONS2
      CSG0Y = CSG0Y/DCONS2         ! normalization
      CSG0Z = CSG0Z/DCONS2
C
C                                  PI0 Teta angle def. vs G0 Beam (exp.)
C
      DCONS3=(CXPIEX*CSG0X+CYPIEX*CSG0Y+CZPIEX*CSG0Z)
C
         IF(DCONS3.GT.1.D0)then
         DCONS3 = 1.D0
         ELSE
         ENDIF
C
      TPIREX=SNGL(DACOS(DCONS3))
      TPIGEX=RADDEG*TPIREX            ! in degrees
C
C
C                                     PI0 FI angle def. vs G0 beam (Exp.)
C
      FPIREX=SNGL(DATAN(CYPIEX/CXPIEX))
C
C                             Quadrant Corrections for TAN
      IF(CYPIEX.LT.0.D0.and.CXPIEX.LT.0.D0)FPIREX=FPIREX+PI
      IF(CYPIEX.LT.0.D0.and.CXPIEX.GT.0.D0)FPIREX=FPIREX+2.*PI
      IF(CYPIEX.GT.0.D0.and.CXPIEX.LT.0.D0)FPIREX=FPIREX+PI
C
      FPIGEX=RADDEG*FPIREX
C
C........................................................      second way
C
C            Second Method of Pi0 polar angle difinition
C            with gamma energies and three points
C
      DEG1 = DBLE(EG1LFE)
      DEG2 = DBLE(EG2LFE)
C
      CONT31 = DSQRT(DEG1**2+DEG2**2+2.D0*DEG1*DEG2*CSPSEX)
      CSPI02 = (DEG1*CZG1EX+DEG2*CZG2EX)/CONT31
      TPIEX2 = RADDEG*SNGL(DACOS(CSPI02))
C
Ct      CONT31 = SQRT(EG1LFE**2+EG2LFE**2+2.*EG1LFE*EG2LFE*CSPSEX)
Ct      CSPI02 = (EG1LFE*CZG1EX+EG2LFE*CZG2EX)/CONT31
Ct      TPIEX2 = RADDEG*ACOS(CSPI02)
C
C........................................................      thired way
C                        HAZ to be Developed!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C            Thired Method of Pi0 polar angle difinition
C            with known Epi0 and three points and biggest Egamma
C            we asume here that Epi0=Ebeam
C
C
Ct      XSHER = (DEG1-DEG2)/(DEG1+DEG2)
Ct      CONT33=(1.D0-XSHER**2)*(1.D0-CSPSEX)
Ct      EPI0EX=SNGL(DSQRT((2.D0*DBLE(EMPI0**2))/CONT33))
Ct      EPI0LF=EPI0EX
C
Ct      CONT32=SQRT(EPI0LF**2-EMPI0**2)
C
Ct      IF(DEG1.GE.DEG2) THEN
Ct      CSPI03=(DEG1*CZG1EX+(DBLE(EPI0LF)-DEG1)*CZG2EX)/DBLE(CONT32)
Ct      ENDIF
Ct      IF(DEG2.GT.DEG1) THEN
Ct      CSPI03=((DBLE(EPI0LF)-DEG2)*CZG1EX+DEG2*CZG2EX)/DBLE(CONT32)
Ct      ENDIF
C
Ct      IF(CSPI03.GT.1.D0)THEN
Ct         write(6,*)'WRONG**** CSPI03= ',CSPI03
C                     for this case we just use the Second method
Ct         CSPI03=CSPI02
Ct      ENDIF
C
Ct      TPIEX3 = RADDEG*DACOS(CSPI03)
C
C............................................................ end of methods
C
      RETURN
C
 101  WRITE(*,*)'IFAIL not Equal to 0  IFAIL= ',IFAIL
C
      RETURN
      END
C
C






