C.
C.**************************************************************************
*____ Author :A. Gasparian                                                 *
*____ date : 11/10/96                                                      *
*                    for pio detectors too                                 *
C.**************************************************************************
C
      SUBROUTINE ROTMAT
C
      COMMON/NEWDET/PI0DET(4)
      COMMON/PAIRC/PLENGTH,PWIDTH,PHEIGHT,PPOS(3),PROTY
C
      PARAMETER (PI=3.14159265)
C..
C..
      T1 = 90.000
      P1 =  0.000
      T2 =180.000
      P2 = 90.000
      T3 = 90.000
      P3 = 90.000
C
      CALL GSROTM(1,T1,P1,T2,P2,T3,P3)                                 ! # 1
C..
C..             # 2 FOR 'CIOP' POSITIONING INSIDE 'CHEN'
      T1 = 90.000
      P1 =  0.000
      T2 =  0.000
      P2 = 90.000
      T3 = 90.000
      P3 =270.000
C
      CALL GSROTM(2,T1,P1,T2,P2,T3,P3)                                 ! # 2
C..
C..             # 3 FOR 'LDHT' AND 'RDHT' POSITIONING IN 'HALA' TETA = 10 deg
      T1 = 90.000
      P1 =  0.000
      T2 = 80.000
      P2 = 90.000
      T3 = 10.000
      P3 =270.000
C
      CALL GSROTM(3,T1,P1,T2,P2,T3,P3)                                 ! # 3
C..
C..             # 4 FOR 'Q1EN' 'Q2EN' 'Q3EN'  POSITIONING IN 'HALA'
      T1 = 90.000
      P1 = 45.000
      T2 = 90.000
      P2 =135.000
      T3 =  0.000
      P3 =  0.000
C
      CALL GSROTM(4,T1,P1,T2,P2,T3,P3)                                 ! # 4
C..
C..             #  FOR 'Q3PL' Left   POSITIONING IN 'Q3BG'
      T1 = 90.000
      P1 =270.000
      T2 = 90.000
      P2 =360.000
      T3 =  0.000
      P3 =  0.000
C
      CALL GSROTM(5,T1,P1,T2,P2,T3,P3)                                 ! # 5
C..
C..             #  FOR 'Q3PL' Dawn  POSITIONING IN 'Q3BG'
      T1 = 90.000
      P1 =180.000
      T2 = 90.000
      P2 =270.000
      T3 =  0.000
      P3 =  0.000
C
      CALL GSROTM(6,T1,P1,T2,P2,T3,P3)                                 ! # 6
C..
C..             #  FOR 'Q3PL' Rigth  POSITIONING IN 'Q3BG'
      T1 = 90.000
      P1 = 90.000
      T2 = 90.000
      P2 =180.000
      T3 =  0.000
      P3 =  0.000
C
      CALL GSROTM(7,T1,P1,T2,P2,T3,P3)                                 ! # 7
C
C..             #  FOR 'MTRG' Moll. target  POSITIONING IN 'MTCH'
      T1 = 90.000
      P1 =  0.000
      T2 =110.000
      P2 = 90.000
      T3 = 20.000
      P3 = 90.000
C
      CALL GSROTM(8,T1,P1,T2,P2,T3,P3)                                 ! # 8
C
C..             #  FOR 'CLD2' dipole Collimator  POSITIONING IN 'DVGP'
      T1 =180.000
      P1 =  0.000
      T2 = 90.000
      P2 = 90.000
      T3 = 90.000
      P3 =  0.000
C
      CALL GSROTM(9,T1,P1,T2,P2,T3,P3)                                 ! # 9
C
C..        #  FOR  NEW VERTICAL 'MTRG' Moll. target  POSITIONING IN 'MTCH'
      T1 =  0.000
      P1 = 90.000
      T2 = 90.000
      P2 =110.000
      T3 = 90.000
      P3 =200.000
C
      CALL GSROTM(10,T1,P1,T2,P2,T3,P3)                                 ! # 10
C
C          For the Top positioning of the Pi0 det
      T1 = 90.000
      P1 =  0.000
      T2 = 90.0 + PI0DET(4)
      P2 = 90.000
      T3 = PI0DET(4)
      P3 = 90.000
C
      CALL GSROTM(11,T1,P1,T2,P2,T3,P3)                                 ! # 11
C
C                For the Battom positioning of the Pi0 det
      T1 = 90.000
      P1 =  0.000
      T2 = 90.0 - PI0DET(4)
      P2 = 90.000
      T3 = PI0DET(4)
      P3 = 90.000
C
      CALL GSROTM(12,T1,P1,T2,P2,T3,P3)                                 ! # 12
C
C                For Pair counter 1
C
C
      T1 = 90.0-PROTY
      P1 =  0.0
      T2 = 90.0
      P2 = 90.0
      T3 = PROTY
      P3 =180.0
C
      CALL GSROTM(13,T1,P1,T2,P2,T3,P3)                                 ! # 13
C
C                For Pair counter 2
      T1 = 90.0+PROTY
      P1 =  0.0
      T2 = 90.0
      P2 = 90.0
      T3 = PROTY
      P3 =  0.0
C
      CALL GSROTM(14,T1,P1,T2,P2,T3,P3)                                 ! # 14
C
C
      PRINT*, '====================================================='
      PRINT*, '====================================================='
      PRINT*, '       Finished defining rotation matricies !!!      '
      PRINT*, '====================================================='
      PRINT*, '====================================================='
      RETURN
      END
C.
C.





