C
C.*************************************************************************
C____ Author :A. Gasparian                                                *
C____ date : 11/11/97                                                     *
C                                                                         *
C                Primakoff Target                                         * 
C                     Lead Target for Primakov Experiment                 *
C.*************************************************************************
C.
      SUBROUTINE TARGET_ETA
C.
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
C
      COMMON/POSITO/POSIT(5)
      COMMON/MSTRNT/STRENT(5)
      COMMON/EDGMAG/POSBGN(5),POSEND(5)
      COMMON/STRCON/GCONS(5)
      COMMON/QUADRD/BORRAD(5),BORSQ(5)
      COMMON/QUADHL/HALFLG(5)
      COMMON/TGTPARMS/TLENGTH,TWIDTH,THEIGHT
      COMMON/THARGT/THRPOS(3)
C
      DIMENSION PAR( 8)
C
C Primakov target  
C
C                        5 cm long 5mm radius He4
      PAR(1) =   0.0
      PAR(2) =   0.5
      PAR(3) =   5.0
C                                                            Lead Target
C
C      NMED  #16 => Fe target  ( temp =7; vacuum )           ! PB NOT MAG
C            #21 => Pb real density Target for Primakov
C      NMED1 # 1           Air not mag                       ! AIR  NOT MAG
C
      CALL GSVOLU( 'PTRG','TUBE ',24 , PAR,3,IVOL)             ! 'PTRG'
      CALL GSPOS('PTRG',1,'HALB',THRPOS(1),THRPOS(2),THRPOS(3),0,'ONLY')
C
C 
C********************************************************
C   Define a dummy wall of air to force GEANT to 
C   step across its boundary
C********************************************************
      PAR(1) = 200
      PAR(2) = PAR(1)
      PAR(3) = 5.0
      CALL GSVOLU( 'TGAW' , 'BOX ' , 1, PAR , 3 , IVOL )
      X=THRPOS(1)
      Y=THRPOS(2)
      Z=THRPOS(3)-5.0
      CALL GSPOS('TGAW',5001,'HALB',X,Y,Z,0,'MANY')
      RETURN
      END
C.
C.
C.
C.







