

/* discriminator on whole detector. */


#include "psim.h"



int MLU1[256],MLU2[256];


void DefineGroups(void);
void ProgramMLUs(void);



/**********************************************/
/* Initialize stuff for the trigger simulator */
/**********************************************/
void init_trigger4(void)
{
   subset *s;
   int i,j;
   
   printf("Defining group  for trigger 4\n");
   /* Unfortunately, this code is duplicated in book_histos.c */
   if(!SubsetExists("ALL")){
      s=AddSubset("ALL");
      if(s){
         for(i=1;i<=27;i++)
            for(j=1;j<=27;j++)
               if(i<9 || i>19 || j<9 || j>19)
                  s->list[s->Num++]=(27*(j-1))+i;
            
         for(i=1;i<=22;i++)
            for(j=1;j<=22;j++)
               if(i<11 || i>12 || j<11 || j>12)
                  s->list[s->Num++]=(22*(j-1))+i+1000;
      }        
   }

}


int trigger4(float Ethresh)
{
   
   /* Note: 
   /* Ethresh is the minimum energy photon we wish to */
   /*  accept in our trigger.                         */

   return FindSubset("ALL")->E > (Ethresh*2.0);

}









